/*
 * File         : test3.java
 * Author       : Guansong Zhang
 * Created      : Thu Jan  8 12:54:05 1998
 * Revision     : $Revision: 1.5 $
 * Updated      : $Date: 1998/09/29 19:48:25 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import spmd.*;

class test3 {
  public static void main(String argv[]) {
    SpmdEnv spmd=new SpmdEnv(argv);

    Procs2 p=new Procs2(2,2);

    if (p.on()) {

      BlockRange x = new BlockRange (10, p.dim(0));
      BlockRange y = new BlockRange (10, p.dim(1));

      Array2Float a = new Array2Float(x,y, spmd.apg);
      Array2Float b = new Array2Float(x,y, spmd.apg);

      Index i = new Index (x);
      Index j = new Index (y);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	j.dim().over();
	for (j.begin(); j.test(); j.next()) {
	  a.data[a.element(i, j)]=10*(1+x.idx(i))+1+y.idx(j);
	} j.dim().revo();
      } i.dim().revo();

      Array2Float tmp1 = new Array2Float(x,y, spmd.apg);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	j.dim().over();
	for (j.begin(); j.test(); j.next()) {
	  tmp1.data[tmp1.element(i,j)]=a.data[a.element(i,j)]+2;
	} j.dim().revo();
      } i.dim().revo();

      Adlib.remap(b, tmp1);

      Adlib.aprintf("%7.1f%"+x.size()+"N", b);

    } p.no();

    spmd.finalize();
  }
}
